/*************************************************
*           BK Emulator v3.8 for Windows         *
*************************************************/

/*
File: Globals.cpp
Version: 1.0.0
Written by: Yuriy Kalmykov <kalmykov@stoik.com>
    Copyright (c) 2002-2004 Yuriy Kalmykov

    BK Emulator is a program emulated hardware environment for running
code for BK 0010(01) in different configurations.

    This code may be used in compiled form in any way you desire.
This file or it's parts can't be redistributed without the authors
written consent, but can be modified for your private needs.
    Providing that this notice and the authors name and all copyright
notices remains intact.

    Please, an email me to know how you are using it and where. You can
ask me for any information about this below code or any attendant
knowledge.

    This file is provided "as is" with no expressed or implied warranty.
The author accepts no liability for any damage or loss of business that
this product may cause.
*/


#include "StdAfx.h"
#include "Globals.h"

CConfig g_Config;

/* это правильная таблица, но на бк всё по особому, даже кои8 там нестандартный
//таблица соответствия верхней половины аскии кодов с 128 по 255, включая псевдографику
static const TCHAR koi8tbl[128] = {
0x2500, 0x2502, 0x250C, 0x2510, 0x2514, 0x2518, 0x251C, 0x2524, 0x252C, 0x2534, 0x253C, 0x2580, 0x2584, 0x2588, 0x258C, 0x2590,
0x2591, 0x2592, 0x2593, 0x2320, 0x25A0, 0x2219, 0x221A, 0x2248, 0x2264, 0x2265, 0xA0,   0x2321, 0xB0,   0xB2,   0xB7,   0xF7,
0x2550, 0x2551, 0x2552, 0x451,  0x2553, 0x2554, 0x2555, 0x2556, 0x2557, 0x2558, 0x2559, 0x255A, 0x255B, 0x255C, 0x255D, 0x255E,
0x255F, 0x2560, 0x2561, 0x401,  0x2562, 0x2563, 0x2564, 0x2565, 0x2566, 0x2567, 0x2568, 0x2569, 0x256A, 0x256B, 0x256C, 0xA9,
_T('ю'), _T('а'), _T('б'), _T('ц'), _T('д'), _T('е'), _T('ф'), _T('г'), _T('х'), _T('и'), _T('й'), _T('к'), _T('л'), _T('м'), _T('н'), _T('о'),
_T('п'), _T('я'), _T('р'), _T('с'), _T('т'), _T('у'), _T('ж'), _T('в'), _T('ь'), _T('ы'), _T('з'), _T('ш'), _T('э'), _T('щ'), _T('ч'), _T('ъ'),
_T('Ю'), _T('А'), _T('Б'), _T('Ц'), _T('Д'), _T('Е'), _T('Ф'), _T('Г'), _T('Х'), _T('И'), _T('Й'), _T('К'), _T('Л'), _T('М'), _T('Н'), _T('О'),
_T('П'), _T('Я'), _T('Р'), _T('С'), _T('Т'), _T('У'), _T('Ж'), _T('В'), _T('Ь'), _T('Ы'), _T('З'), _T('Ш'), _T('Э'), _T('Щ'), _T('Ч'), _T('Ъ')
};
*/
//вот бкшная таблица
//таблица соответствия верхней половины аскии кодов с 128 по 255, включая псевдографику
static const TCHAR koi8tbl[128] =
{
	//{200..237} этих символов на бк нету.
	_T(' '), _T(' '), _T(' '), _T(' '), _T(' '), _T(' '), _T(' '), _T(' '),
	_T(' '), _T(' '), _T(' '), _T(' '), _T(' '), _T(' '), _T(' '), _T(' '),
	_T(' '), _T(' '), _T(' '), _T(' '), _T(' '), _T(' '), _T(' '), _T(' '),
	_T(' '), _T(' '), _T(' '), _T(' '), _T(' '), _T(' '), _T(' '), _T(' '),
	//{240..277}
	0xb6,    0x2534,  0x2665,  0x2510,  0x2561,  0x251c,  0x2514,  0x2550,
	0x2564,  0x2660,  0x250c,  0x252c,  0x2568,  0x2193,  0x253c,  0x2551,
	0x2524,  0x2190,  0x256c,  0x2191,  0x2663,  0x2500,  0x256b,  0x2502,
	0x2666,  0x2518,  0x256a,  0x2565,  0x2567,  0x255e,  0x2192,  0x2593,
	//{300..337}
	_T('ю'), _T('а'), _T('б'), _T('ц'), _T('д'), _T('е'), _T('ф'), _T('г'),
	_T('х'), _T('и'), _T('й'), _T('к'), _T('л'), _T('м'), _T('н'), _T('о'),
	_T('п'), _T('я'), _T('р'), _T('с'), _T('т'), _T('у'), _T('ж'), _T('в'),
	_T('ь'), _T('ы'), _T('з'), _T('ш'), _T('э'), _T('щ'), _T('ч'), _T('ъ'),
	//{340..377}
	_T('Ю'), _T('А'), _T('Б'), _T('Ц'), _T('Д'), _T('Е'), _T('Ф'), _T('Г'),
	_T('Х'), _T('И'), _T('Й'), _T('К'), _T('Л'), _T('М'), _T('Н'), _T('О'),
	_T('П'), _T('Я'), _T('Р'), _T('С'), _T('Т'), _T('У'), _T('Ж'), _T('В'),
	_T('Ь'), _T('Ы'), _T('З'), _T('Ш'), _T('Э'), _T('Щ'), _T('Ч'), _T('Ъ')
};

static const unsigned char bk_codes[] =
{
	('б'), ('в'), ('ч'), ('з'), ('д'), ('е'), ('ц'), ('ъ'), ('й'), ('к'), ('л'), ('м'), ('н'), ('о'), ('п'), ('р'),
	('т'), ('у'), ('ф'), ('х'), ('ж'), ('и'), ('г'), ('ю'), ('ы'), ('э'), ('я'), ('щ'), ('ш'), ('ь'), ('а'), ('с'),
	('Б'), ('В'), ('Ч'), ('З'), ('Д'), ('Е'), ('Ц'), ('Ъ'), ('Й'), ('К'), ('Л'), ('М'), ('Н'), ('О'), ('П'), ('Р'),
	('Т'), ('У'), ('Ф'), ('Х'), ('Ж'), ('И'), ('Г'), ('Ю'), ('Ы'), ('Э'), ('Я'), ('Щ'), ('Ш'), ('Ь'), ('А'), ('С')
};

CString WordToOctString(WORD word)
{
	CString dst;
	LPTSTR buf = dst.GetBufferSetLength(7);

	for (int i = 5; i >= 0; --i)
	{
		buf[i] = TCHAR(060 + (word & 7));
		word >>= 3;
	}

	buf[6] = 0;
	dst.ReleaseBuffer();
	return dst;
}


CString ByteToOctString(BYTE byte)
{
	CString dst;
	LPTSTR buf = dst.GetBufferSetLength(7);

	for (int i = 2; i >= 0; --i)
	{
		buf[i] = TCHAR(060 + (byte & 7));
		byte >>= 3;
	}

	buf[3] = 0;
	dst.ReleaseBuffer();
	return dst;
}


WORD OctStringToWord(const CString &str)
{
	int word = 0;
	_stscanf_s(str, _T("%o"), &word);
	return (WORD)word;
}


CString IntToString(int iInt, int radix)
{
	CString str;
	_itot_s(iInt, str.GetBufferSetLength(256), 256, radix);
	str.ReleaseBuffer();
	return str;
}

CString IntToFileLengthString(int iInt)
{
	CString str;

	while (iInt >= 1000)
	{
		CString strTriple = IntToString(iInt % 1000, 10);
		str = strTriple + str;
		str = _T(" ") + str;
		iInt /= 1000;
	}

	CString strTriple = IntToString(iInt, 10);
	str = strTriple + str;
	return str;
}


CString MsTimeToTimeString(int msTime)
{
	CString strMin = IntToString(msTime / 60000, 10);
	CString strSec;
	strSec.Format(_T("%02i"), msTime / 1000 % 60);
	return strMin + _T(':') + strSec;
}


CString BKToUNICODE(BYTE *pBuff, int size)
{
	CString strRet = _T("");
	TCHAR tch;

	for (int i = 0; i < size; i++)
	{
		tch = BKToUNICODE_Byte(pBuff[i]);

		if (tch == 0)
		{
			break;
		}

		strRet += tch;
	}

	return strRet;
}

TCHAR BKToUNICODE_Byte(BYTE b)
{
	if (b == 0)
	{
		return 0;
	}

	if (b < 32)
	{
		return _T(' ');
	}
	else if (b >= 32 && b < 127)
	{
		return (TCHAR)b;
	}
	else if (b == 127)
	{
		return (TCHAR)0x25a0;
	}
	else if (b >= 128)
	{
		return (TCHAR)koi8tbl[b - 128];
	}

	return 0; //этот return не должен выполниться в принципе.
}

/*
преобразование юникодной строки в бкшный кои8.
вход:
    ustr - преобразуемая строка
    pBuff - буфер, куда выводится результат
    bufSize - размер буфера
    bFillBuf - флаг. если строка короче размера буфера, буфер до конца забивается пробелами. (конца строки - 0 нету.)
*/
void UNICODEtoBK(CString &ustr, BYTE *pBuff, int bufSize, bool bFillBuf)
{
	int len = ustr.GetLength();
	int n = 0;
	int bn = 0;
	TCHAR ch;
	BYTE b;

	while (n < len)
	{
		ch = ustr.GetAt(n++); //берём очередной символ

		if (ch == _T('\t'))
		{
			b = 9;
		}
		else if (ch == _T('\n'))
		{
			b = 10;
		}
		else if (ch < 32) //если символ меньше пробела,
		{
			b = 32;  //то будет пробел
		}
		else if ((32 <= ch) && (ch < 127)) //если буквы-цифры- знаки препинания
		{
			b = LOBYTE(ch); // то буквы-цифры- знаки препинания
		}
		else if (ch == 0x25a0) //если такое
		{
			b = 127; //то это. это единственное исключение в нижней половине аски кодов
		}
		else //если всякие другие символы
		{
			//то ищем в таблице нужный нам символ, а его номер - будет кодом кои8
			int i = 0;
			b = 32; //если такого символа нету в таблице - будет пробел

			while (i < 128)
			{
				if (koi8tbl[i] == ch)
				{
					b = LOBYTE(i) + 0200;
					break;
				}

				i++;
			}
		}

		pBuff[bn++] = b;

		if (bn >= bufSize)
		{
			break;
		}
	}

	if (bFillBuf && (len < bufSize))
	{
		while (bn < bufSize)
		{
			pBuff[bn++] = 32;
		}
	}
}


void ANSIToBK(BYTE &ch)
{
	if (ch == ('\t'))
	{
		ch = 9;
		return;
	}
	else if (ch == ('\n'))
	{
		ch = 10;
		return;
	}
	else

		/*
		if (ch < 32)
		{
		    ch = _T(' ');
		    return;
		}
		else
		*/
		if (ch >= 32 && ch <= 127)
		{
			return;
		}

	if (ch >= 192)
	{
		ch = bk_codes[ch - 192];
	}
}
#ifdef _DEBUG
//функция для вывода сообщений об ошибках при отладке, когда совсем ничего не понятно, почему не работает
void GetLastErrorOut(LPTSTR lpszFunction)
{
	// Retrieve the system error message for the last-error code
	LPVOID lpMsgBuf;
	DWORD dw = GetLastError();
	FormatMessage(
	    FORMAT_MESSAGE_ALLOCATE_BUFFER |
	    FORMAT_MESSAGE_FROM_SYSTEM |
	    FORMAT_MESSAGE_IGNORE_INSERTS,
	    NULL,
	    dw,
	    MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
	    (LPTSTR) &lpMsgBuf,
	    0, NULL);
	// Display the error message and exit the process
	CString strErr;
	strErr.Format(TEXT("%s failed with error %u: %s"), lpszFunction, dw, (LPCTSTR)lpMsgBuf);
	MessageBox(NULL, strErr.GetBuffer(), TEXT("Error"), MB_OK);
	LocalFree(lpMsgBuf);
}
#endif
